import logger from '../utils/objects/logger.js';
import JDLApplicationConfiguration from './jdl-application-configuration.js';
import StringJDLApplicationConfigurationOption from './string-jdl-application-configuration-option.js';
import IntegerJDLApplicationConfigurationOption from './integer-jdl-application-configuration-option.js';
import BooleanJDLApplicationConfigurationOption from './boolean-jdl-application-configuration-option.js';
import ListJDLApplicationConfigurationOption from './list-jdl-application-configuration-option.js';
import JDLApplicationDefinition from './jdl-application-definition.js';
const applicationDefinition = new JDLApplicationDefinition();
export default function createApplicationConfigurationFromObject(configurationObject = {}) {
    const configuration = new JDLApplicationConfiguration();
    Object.keys(configurationObject).forEach(optionName => {
        const optionValue = configurationObject[optionName];
        if (!applicationDefinition.doesOptionExist(optionName)) {
            logger.debug(`Unrecognized application option name and value: '${optionName}' and '${optionValue}'.`);
            return;
        }
        configuration.setOption(createApplicationJDLConfigurationOption(optionName, optionValue));
    });
    return configuration;
}
export function createApplicationNamespaceConfigurationFromObject(parsedNamespaceConfigs = {}) {
    return Object.entries(parsedNamespaceConfigs).map(([namespace, parsedConfig]) => {
        const configuration = new JDLApplicationConfiguration(namespace);
        for (const [optionName, optionValue] of Object.entries(parsedConfig)) {
            configuration.setOption(createUnknownJDLConfigurationOption(optionName, optionValue));
        }
        return configuration;
    });
}
function createUnknownJDLConfigurationOption(name, value) {
    let type;
    if (typeof value === 'boolean') {
        type = 'boolean';
    }
    else if (/^\d+$/.test(value)) {
        value = parseInt(value, 10);
        type = 'integer';
    }
    else if (Array.isArray(value)) {
        type = 'list';
    }
    else if (typeof value === 'string') {
        type = 'string';
    }
    else {
        throw new Error(`Unknown value type for option ${name}`);
    }
    return createJDLConfigurationOption(type, name, value);
}
function createApplicationJDLConfigurationOption(name, value) {
    const type = applicationDefinition.getTypeForOption(name);
    return createJDLConfigurationOption(type, name, value);
}
function createJDLConfigurationOption(type, name, value) {
    switch (type) {
        case 'string':
            return new StringJDLApplicationConfigurationOption(name, value, applicationDefinition.shouldTheValueBeQuoted(name));
        case 'integer':
            return new IntegerJDLApplicationConfigurationOption(name, value);
        case 'boolean':
            return new BooleanJDLApplicationConfigurationOption(name, value);
        case 'list':
            return new ListJDLApplicationConfigurationOption(name, value);
        case 'quotedList':
            return new ListJDLApplicationConfigurationOption(name, value, true);
        default:
            throw new Error(`Unrecognized option type: ${type}.`);
    }
}
